=== debian/changelog ===
rocsparse (5.5.1-1) unstable; urgency=medium

  * New upstream version 5.5.1
  * d/rules: drop gfx1011 architecture from librocsparse0.
    The HIP runtime will fall back to using gfx1010.
  * d/rules: use compressed DWARF 5 debug symbols
  * Fix FTBFS with Sphinx 7.1 by specifying full filepath to local
    copy of MathJax.js (Closes: #1042702).

 -- Cordell Bloor <cgmb@slerp.xyz>  Sun, 30 Jul 2023 20:18:24 -0600

rocsparse (5.3.0+dfsg-8) unstable; urgency=medium

  * Fix librocsparse0-tests-data install path
  * d/t/control: limit autopkgtests to amd64, arm64, and ppc64el

 -- Cordell Bloor <cgmb@slerp.xyz>  Wed, 28 Jun 2023 17:35:03 -0600

rocsparse (5.3.0+dfsg-7) unstable; urgency=medium

  * Split additional arch-specific and arch-independent build steps to
    fix binary-all FTBFS. (Closes: #1038676)

 -- Cordell Bloor <cgmb@slerp.xyz>  Tue, 20 Jun 2023 00:05:33 -0600

rocsparse (5.3.0+dfsg-6) unstable; urgency=medium

  * Upload to unstable
  * Add myself to Uploaders

 -- Christian Kastner <ckk@debian.org>  Fri, 16 Jun 2023 08:46:39 +0200

rocsparse (5.3.0+dfsg-5) experimental; urgency=medium

  [ Christian Kastner ]
  * Drop <!nodoc> restriction from Suggests.

  [ Cordell Bloor ]
  * Add librocsparse0-tests-data package for architecture-independent
    test data.
  * d/rules: disable lto

 -- Cordell Bloor <cgmb@slerp.xyz>  Mon, 12 Jun 2023 12:13:45 -0600

rocsparse (5.3.0+dfsg-4) experimental; urgency=medium

  * Enable build-time test suite.
  * Add librocsparse0-tests package providing autopkgtests.
  * Add librocsparse-doc package providing HTML documentation.
  * d/librocsparse-dev.examples: add example code
  * d/rules: remove unnecessary filter
  * d/rules: disable fortify source
  * d/control: fix maintainer name
  * d/control: add libamdhip64-dev to librocsparse-dev recommends

 -- Cordell Bloor <cgmb@slerp.xyz>  Mon, 05 Jun 2023 18:31:25 -0600

rocsparse (5.3.0+dfsg-3) unstable; urgency=medium

  * Update patch DEP-3 metadata fields.
  * d/rules: use DWARF 4 debug symbols
  * d/rules: enable hardening flags
  * d/rules: enable gfx1010 and gfx1011
  * Add d/p/0003-fix-oob-access-in-rocsparse-test.patch
    to fix out-of-bound accesses in test suite.
  * Reduce arch to amd64, arm64, ppc64el

 -- Cordell Bloor <cgmb@slerp.xyz>  Wed, 08 Mar 2023 13:52:55 -0700
