=== debian/tests/control ===
Test-Command: /bin/sh debian/tests/upstream-binaries librocsparse0-tests
Depends: librocsparse0-tests
Restrictions: skippable, allow-stderr
Architecture: amd64 arm64 ppc64el
