=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocsparse-$1.tar.gz%" \
    https://github.com/rocmsoftwareplatform/rocsparse/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
